#define NO_BIT_DEFINES
/* ----------------------------------------------------------------------- */
/* Template source file generated by piklab */
#include <pic16f690.h>

/* ----------------------------------------------------------------------- */
/* Configuration bits: adapt to your setup and needs */
typedef unsigned int word;
word __at 0x2007 CONFIG = _INTRC_OSC_NOCLKOUT & _WDT_OFF & _PWRTE_ON & _MCLRE_OFF & _CP_OFF & _CPD_OFF & _BOR_ON & _IESO_ON & _FCMEN_ON;

typedef union {
	struct {
		unsigned char LSB:1;
		unsigned char :1;
		unsigned char :1;
		unsigned char :1;
		unsigned char :1;
		unsigned char :1;
		unsigned char :1;
		unsigned char SIGNUM:1;
	};
	struct {
		unsigned char B0:1;
		unsigned char B1:1;
		unsigned char B2:1;
		unsigned char B3:1;
		unsigned char B4:1;
		unsigned char B5:1;
		unsigned char B6:1;
		unsigned char B7:1;
	};
	unsigned char allapotbyte;
} allapotbitek ;

allapotbitek OPORTAbits,OPORTBbits,OPORTCbits;
allapotbitek IPORTAbits,IPORTBbits,IPORTCbits;

#define OPORTA 	OPORTAbits.allapotbyte
#define OPORTB 	OPORTBbits.allapotbyte
#define OPORTC	OPORTCbits.allapotbyte

#define IPORTA 	IPORTAbits.allapotbyte
#define IPORTB 	IPORTBbits.allapotbyte
#define IPORTC	IPORTCbits.allapotbyte

#define DO_pin 	OPORTCbits.B5
#define DI_pin 	IPORTCbits.B5
#define DOUTPUT	TRISCbits.TRISC5 = 0
#define DINPUT	TRISCbits.TRISC5 = 1

#define CLK_pin 	OPORTCbits.B4
#define CLK_tris	TRISCbits.TRISC4
#define STB_pin 	OPORTCbits.B3
#define STB_tris	TRISCbits.TRISC3

#define LOW	 0
#define HIGH 1

__code unsigned char segments[ 10 ] = {
	0b00111111 ,
 	0b00000110 ,
  	0b01011011 ,
   	0b01001111 ,
	0b01100110 ,
 	0b01101101 ,
  	0b01111101 ,
   	0b00000111 ,
	0b01111111 ,
 	0b01101111 };	// számjegyek 0-9-ig a 7szegmenses kijelzőn

__code unsigned char karika[ 6 ] = {

	0b00000010,
 	0b00000100,
	0b00010000,
 	0b00001000,
  	0b01000000,
    0b00100000 }; 	// körcikkek

void isr() __interrupt 0
{ 
    /* << megszakítási kód helye >> */
}

void oscinit()
{
	OSCCONbits.IRCF0 = 1;
	OSCCONbits.IRCF1 = 1;
	OSCCONbits.IRCF2 = 1;
}

void portinit()
{
	TRISA = 0xFF;
	TRISB = 0xFF;
	TRISC = 0xFF;
	
	PORTA = 0;
	PORTB = 0;
	PORTC = 0;
	
	ANSEL = 0;
	ANSELH = 0;

	OPORTA = 0;
	OPORTB = 0;
	OPORTC = 0;

	STB_tris = 0;
	CLK_tris = 0;
}

void writeport()
{
	PORTA = OPORTA;
	PORTB = OPORTB;
	PORTC = OPORTC;
}

void readport()
{
	IPORTA = PORTA;
	IPORTB = PORTB;
	IPORTC = PORTC;
}

void delay( unsigned int cycle )
{
	unsigned int i;

	for( i = 0 ; i < cycle ; i++ );
}

void sendcommand( unsigned char command )
{
	unsigned char	i;
	
	for( i = 0 ; i < 8 ; i++ )
	{
		CLK_pin = LOW;
		writeport();
	
		if( ( command & 0x01 ) == 0x01 )
		{
			DINPUT;
		}
		else
		{
			DO_pin = 0;
			writeport();
			DOUTPUT;
		}
		
		command >>= 1;
		CLK_pin = HIGH;
		writeport();
	}

	DINPUT;

}

void main()
{
    /* << ide a kódot >> */
	unsigned char number,ciklus,i;
	unsigned char charcode0;
	unsigned char charcode1,charcode2;
	unsigned char outchar;
	unsigned char dnumber,dciklus;

	i = 0;
	number = 0;
	ciklus = 0;

	dnumber = 7;
	dciklus = 3;
	
	portinit();
	oscinit();

// -----------------------------------------------
// Kijelző alapba állítása
	
	STB_pin = LOW;
	writeport();
	sendcommand( 0x40 );

	STB_pin = HIGH;
	writeport();
	
	STB_pin = LOW;
	writeport();

	sendcommand( 0xC0 );
	sendcommand( 0 );
	sendcommand( 0 );
	sendcommand( 0 );
	sendcommand( 0 );
	sendcommand( 0 );
	sendcommand( 0 );
	sendcommand( 0 );
	sendcommand( 0 );
	sendcommand( 0 );
	sendcommand( 0 );
	sendcommand( 0 );
	sendcommand( 0 );
	sendcommand( 0 );
	sendcommand( 0 );
	
	STB_pin = HIGH;
	writeport();

	STB_pin = LOW;
	writeport();

	sendcommand( 0x03 );
	STB_pin = HIGH;
	writeport();
// ----------------------------------------------
// Főhurok
	
	while( 1 )
	{
		STB_pin = LOW;
		writeport();

		sendcommand( 0x40);

		STB_pin = HIGH;
		writeport();

		STB_pin = LOW;
		writeport();

		sendcommand( 0xC0 );

		if( (--dciklus) == 0 )
		{
			ciklus++;
			dciklus = 2;
		}
		
		if( ciklus == 6 ) ciklus = 0;
		
		charcode0 = karika[ ciklus ];
		charcode1 = segments[ (number & 0x0F) ];
		charcode2 = segments[ (number >> 4) ];

		for( i = 0 ; i < 7 ; i++ )
		{
			outchar = (( charcode2 & 0x01 ) << 2 ) | (( charcode1 & 0x01 ) << 3 ) | (( charcode0 & 0x01 ) << 6 );
			sendcommand( outchar ); /**/
			sendcommand( 0x00 );
			charcode0 >>= 1;
			charcode1 >>= 1;
			charcode2 >>= 1;
		}

		if( (--dnumber) == 0 )
		{
			number ++;
			dnumber = 7;
		}
		if( ( number & 0x0F ) == 10 ) number += 0x06;	// 10-es számrendszerben számol
		if( ( number >> 4 ) == 10 ) number = 0;
		
		STB_pin = HIGH;
		writeport();

		delay( 100 );

		STB_pin = LOW;
		writeport();
		
		sendcommand( 0x8F );
		STB_pin = HIGH;
		writeport();

		delay( 10000 );

	}
	while( 1 );

}
